
local StoneGateV5 = ...


-- Apply building asset processor
StoneGateV5:registerAssetProcessor("models/hoardings/hoardingS2.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/hoardings/extensionS2.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/hoardings/hoardingS3.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/hoardings/extensionS3.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/hoardings/hoardingS1.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/hoardings/hoardingSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV5:registerAssetProcessor("models/hoardings/hoardingOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

function registerHoardingPart(_nameSize, _nameFbx, _nameAsset, _buildingZone)
    StoneGateV5:registerAssetId("models/hoardings/" .. _nameSize .. ".fbx/Prefab/hoarding/step_5_" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration hoardings part
    StoneGateV5:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
    })

    StoneGateV5:registerPrefabComponent("models/hoardings/" .. _nameSize .. ".fbx/Prefab/hoarding/step_5_" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = _buildingZone
    })
end

function registerHoardingPartMajor(_nameSize, _nameFbx, _nameAsset, _buildingZone)
    StoneGateV5:registerAssetId("models/hoardings/" .. _nameSize .. ".fbx/Prefab/hoarding/step_5_" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration hoarding part
    StoneGateV5:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 2 }
		}
	}
    })
end

registerHoardingPart( "hoardingS2", "Hoarding_S2L0R0", "HOARDING_S2L0R0", { 0, 0 } )
registerHoardingPart( "hoardingS2", "Hoarding_S2L0R1", "HOARDING_S2L0R1", { 0, 0 } )
registerHoardingPart( "hoardingS2", "Hoarding_S2L1R0", "HOARDING_S2L1R0", { 0, 0 } )
registerHoardingPart( "hoardingS2", "Hoarding_S2L1R1", "HOARDING_S2L1R1", { 0, 0 } )
registerHoardingPart( "extensionS2", "Extension_S2L0R0", "EXTENSION_S2L0R0", { 0, 0 } )
registerHoardingPart( "hoardingS3", "Hoarding_S3L0R0", "HOARDING_S3L0R0", { 0, 0 } )
registerHoardingPart( "hoardingS3", "Hoarding_S3L0R1", "HOARDING_S3L0R1", { 0, 0 } )
registerHoardingPart( "hoardingS3", "Hoarding_S3L1R0", "HOARDING_S3L1R0", { 0, 0 } )
registerHoardingPart( "hoardingS3", "Hoarding_S3L1R1", "HOARDING_S3L1R1", { 0, 0 } )
registerHoardingPart( "extensionS3", "Extension_S3L0R0", "EXTENSION_S3L0R0", { 0, 0 } )
registerHoardingPartMajor( "hoardingS1", "Sst_HoardingA", "HOARDING_S1_A", { 0, 0 } )
registerHoardingPartMajor( "hoardingS1", "Sst_HoardingB", "HOARDING_S1_B", { 0, 0 } )
registerHoardingPart( "hoardingSmallGate", "SGate_HoardingA", "SGATE_HOARDING_A", { 0, 0 } )
registerHoardingPart( "hoardingOctogonalTower", "Octogonal_HoardingExt", "OTOWER_HOARDING_EXT", { 0, 0 } )
registerHoardingPart( "hoardingOctogonalTower", "Octogonal_Hoarding", "OTOWER_HOARDING", { 0, 0 } )
